/* ccgo: board.hh
 * 
 * Copyright 2002,2003 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef BOARD_HH
#define BOARD_HH
#include "go.hh"
namespace go
{
	class Board
	{
	public:
		static State other(State);
		static State stone(Turn);
	protected:
		int size;
		State * board;
	public:
		Board(unsigned = 19);
		virtual ~Board();
		int get_size() const;
		virtual Board * dup() const;
		virtual void copy(const Board &);
		static State turn_state(Turn);
		State get_site(const Loc &) const;
		void set_site(const Loc &, State);
		State & operator[] (const Loc &);
	};
}
#endif // BOARD_HH
