/* ccgo: debug.hh
 *
 * Copyright 2008 Chun-Chung Chen <cjj@u.washington.edu>
 *
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef DEBUG_HH
#define DEBUG_HH

#include "config.hh"
#include <iostream>
#include <cassert>

#ifdef DEBUG
#define debug(x) (void)({x})
#define debug_enabled() (true)
#else
#define debug(x) (void) 0
#define debug_enabled() (false)
#endif

extern int debug_level;

enum DebugLevels {
	DBG_ERROR = 1,
	DBG_WARNING = 2,
	DBG_INFO = 3,
	DBG_DEBUG = 4
};

// void debug_message(int level, std::string message);
std::ostream & debug_stream(int level);
class DummyOut {};
extern DummyOut dummy_out;

template<class TT>
DummyOut & operator<< (DummyOut & o, TT)
{
	return o;
}


#ifdef DEBUG
#define msg(x) debug_stream(x)
#else
#define msg(x) dummy_out
#endif

#endif // DEBUG_HH
