/* ccgo: game_setup.hh
 * 
 * Copyright 2002,2003 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef GAME_SETUP_HH
#define GAME_SETUP_HH
#include <gtkmm/dialog.h>
#include <gtkmm/adjustment.h>
#include <gtkmm/entry.h>
#include <gtkmm/optionmenu.h>

namespace go {
	class PlayerSelect :
		public Gtk::OptionMenu
	{
		Gtk::Entry path;
	public:
		PlayerSelect();
		std::string get_path();
		void set_path(const std::string &);
	};

	class GameSetup :
		public Gtk::Dialog
	{
		void on_response(int);
		Gtk::Adjustment * board_size;
		Gtk::Adjustment * handicap;
		Gtk::Adjustment * komi;
		PlayerSelect white;
		PlayerSelect black;
		void board_size_change();
		void handicap_change();
	public:
		GameSetup();
	};
}
#endif // GAME_SETUP_HH
