/* ccgo: gmp/player.hh
 * 
 * Copyright 2002,2003 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef GMP_PLAYER_HH
#define GMP_PLAYER_HH
#include "device.hh"
#include "../player.hh"
namespace gmp
{
	class Player :
		virtual public Device,
		virtual public go::Player
	{
		go::Turn play_turn;
	protected:
		unsigned answer(Query);
		bool move_in(unsigned);
		bool undo_in(unsigned);
	public:
		virtual ~Player();
		void set_arena(go::Arena *);
		void enable_player();
		void disable_player();
		void notify_setup(const go::Board & board);
		void notify_handicap(unsigned n);
		void notify_put(const go::Loc &);
		void notify_pass();
		void notify_undo();
	};
}
#endif // GMP_PLAYER_HH
