/* ccgo: go/list.hh
 * 
 * Copyright 2004 Chun-Chung Chen <cjj@u.washington.edu>
 *
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

// Game list maintainer
#ifndef GO_LIST_HH
#define GO_LIST_HH

#include <game.hh>

namespace ccgo
{
	class List
	{
	public:
		List();
		~List();
		Game * new_game();
		Game * load_game(std::string filename);
		unsigned size();
		Game * get_game(unsigned index);
		Node * get_node(unsigned index);
		std::string get_name(unsigned index);

		void set_node(Node * node);
	private:
		struct G {
			Game * game;
			Node * node; // default node
			std::string file;
		};
		std::vector<G> glist;
	};
}
#endif // GO_LIST_HH
