/* ccgo: handicap.hh
 * 
 * Copyright 2002,2003 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef HANDICAP_HH
#define HANDICAP_HH
#include "move.hh"
#include <string>
namespace go {
	class Handicap :
		public Move
	{
		std::vector<Loc> handi;
	public:
		Handicap(unsigned);
		Handicap(const std::vector<Loc> &);
		Handicap(const Handicap &);
		Modifi * dup() const;
		bool check(const Game &);
		virtual void apply(Game &) const;
		virtual void undo(Game &) const;
		virtual std::string as_string() const;
		const std::vector<Loc> get_handi() const;
	};
}
#endif // HANDICAP_HH
