/* ccgo: igs/board.hh
 * 
 * Copyright 2002,2003 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef IGS_BOARD_HH
#define IGS_BOARD_HH
#include "datetime.hh"
#include <go.hh>
#include <string>

namespace igs
{
	class Board
	{
	public:
		enum StopType {
			STOP_UNKNOWN,
			STOP_ADJOURN,
			STOP_DISCONNECT
		};

		class Record
		{
			go::Turn who;
			StopType stop;
		public:
			Record();
			void set(const std::string &);
			Glib::ustring to_str() const;
			operator bool() const;
		};

		std::string white;
		int w_cap;
		int w_time;
		int w_stones;
		std::string black;
		int b_cap;
		int b_time;
		int b_stones;
		double komi;
		int handicap;
		int board_size;
		int * state;

		bool is_score;
		std::string score;
		Datetime date;
		Record record;
		// std::string record;

		Board();
		~Board();
		void set_size(int);
		int & site(int, int);
		const int & site(int, int) const;
	};
}
#endif // IGS_BOARD_HH
