/* ccgo: igs/encode.cc
 * 
 * Copyright 2002,2003 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#include "../config.hh"
#include "../gettext.h"
#include "encode.hh"
#include <glibmm/convert.h>

#define _(String) Glib::locale_to_utf8(gettext(String))

using namespace igs;

Glib::ustring igs::auto_convert(const std::string & s)
{
	Glib::ustring u = s;
	if (u.validate()) return u;
	u =_("[unknown encoding]");
	static const char * try_encoding[] = {"BIG5", "SJIS", "GB2312", "EUC-JP", 0};
	int i = 0;
	const char * c = 0;
	unsigned len = s.length();
	while (try_encoding[i]) {
		bool ok = false;
		Glib::ustring uu;
		try {
			uu = Glib::convert(s, "UTF-8", try_encoding[i]);
			ok = true;
		} catch (Glib::ConvertError e) {
			ok = false;
		}
		if (ok && uu.length() < len) {
			u = uu;
			len = uu.length();
			c = try_encoding[i];
		}
		i ++;
	}
	if (c) {
		// std::cerr << c << " string found" << std::endl;
	}
	return u;
}
