/* ccgo: igs/fork.hh
 * 
 * Copyright 2002,2003 Chun-Chung Chen <cjj@u.washington.edu>
 *
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef IGS_FORK_HH
#define IGS_FORK_HH
#include "connect.hh"
#include <glibmm.h>
#include <string>
namespace igs
{
	class Fork :
		virtual public Connect
	{
		int to_child;     // file handle to send message to child
		int from_child; // file handle to read from child
		pid_t child_pid; // pid of the child process

		sigc::connection grab_line_connection;
		bool grab_line(Glib::IOCondition);
		bool read_buffer();

		sigc::connection time_up_connection;
		bool time_up();
		int idle_time;  // idle time after last read

	protected:
		std::string line_buffer;
	public:
		Fork(const std::string &);
		virtual ~Fork();
		virtual void send_line(const std::string &);

		bool open_conn(const std::string &);
		void close_conn();
	};
}
#endif // IGS_FORK_HH
