/* ccgo: igs/line_box.cc
 * 
 * Copyright 2002,2003 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#include "line_box.hh"

using namespace igs;

bool LineBox::on_key_press_event(GdkEventKey * e)
{
	switch (e->keyval) {
	case GDK_Up:
		if (ri == hist.rend()) break;
		if (ri == hist.rbegin()) current_line = get_text();
		set_text(* ri);
		++ ri;
		break;
	case GDK_Down:
		if (ri == hist.rbegin()) break;
		-- ri;
		if (ri == hist.rbegin()) set_text(current_line);
		else set_text(* (ri - 1));
		break;
	default:
		return Gtk::Entry::on_key_press_event(e);
	}
	return true;
}

void LineBox::on_activate()
{
	Gtk::Entry::on_activate();
	hist.push_back(get_text());
	if (hist.size() > 100) hist.erase(hist.begin());
	for (std::vector<std::string>::iterator i = hist.begin(); i + 1 != hist.end(); i ++) if (* i == hist.back()) {
		hist.erase(i);
		break;
	}
	ri = hist.rbegin();
	current_line = "";
	set_text(current_line);
}

LineBox::LineBox()
{
	ri = hist.rbegin();
}

void LineBox::clear_history()
{
	hist.clear();
	ri = hist.rbegin();
}

const std::string & LineBox::get_line()
{
	if (hist.size()) return hist.back();
	else return current_line;
}
