/* ccgo: igs/parser/automatch.cc
 * 
 * Copyright 2002,2003 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#include "automatch.hh"
#include <sstream>

using namespace igs;
using namespace parser;

// extern Automatch parser_automatch;
Automatch Automatch::parser_automatch(& Automatch::parser_automatch);

Parser * Automatch::id(Control * c) const
{
	if (c->get_num_cmd() != 36) return 0;
	Automatch * a = new Automatch(c);
	return a;
}

Automatch::Automatch(Parser * p) :
	Parser(p)
{
}

Automatch::Automatch(Control * c) :
	Parser(c)
{
	complete = false;
}

Automatch::~Automatch()
{
}

bool Automatch::process()
{
	if (complete) return false;
	if (control->get_num_cmd() != 36) return false;
	std::istringstream s(control->get_cmd_dat());
	std::string d;
	if (m.get_automatch()) {
		s >> d >> d;
		if (d != "accept") return false;
		control->match_request(m);
		complete = true;
		return true;
	}
	s >> m.opponent;
	s >> d;
	if (d != "wants") return false;
	s >> m.board_size;
	s.get();
	s >> d >> d >> m.time;
	s >> d >> d >> m.byo_time;
	s >> d >> d >> m.byo_stone;
	m.set_option = true;
	m.set_automatch(true);
	return true;
}
