/* ccgo: igs/parser/results.cc
 * 
 * Copyright 2002,2003 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#include "results.hh"
#include "../result.hh"
#include <sstream>

using namespace igs;
using namespace parser;

// extern Results parser_results;
Results Results::parser_results(& Results::parser_results);

Parser * Results::id(Control * c) const
{
	if (c->get_num_cmd() != 25 || c->get_cmd_dat() != "File") return 0;
	return new Results(c);
}

Results::Results(Parser * p) :
	Parser(p)
{
}

Results::Results(Control * c) :
	Parser(c)
{
	finish = false;
}

Results::~Results()
{
}

bool Results::process()
{
	if (finish) return false;
	if (control->get_line() == "25 File") {
		control->game_result(list);
		finish = true;
		return true;
	}
	Result r;
	if (r.build(control->get_line())) list.push_back(r);
	// if (r) control->game_result(r);
	return true;
}
