/* ccgo: igs/result.hh
 * 
 * Copyright 2002,2003 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef IGS_RESULT_HH
#define IGS_RESULT_HH
#include "player.hh"
#include <go.hh>
#include <string>
namespace igs
{
	enum WinType {
		WIN_COUNT,
		WIN_RESIGN,
		WIN_TIME
	};

	class Result
	{
		bool ok;
	public:
		std::string raw;
		std::string white;
		Player::Rank w_rank;
		std::string black;
		Player::Rank b_rank;
		go::Turn winer;
		unsigned handicap;
		double komi;
		unsigned board_size;
		WinType win_type;
		double win;
		int date;
		int hour;
		int minute;
		bool rated;

		Result();
		bool build(const std::string &);
		operator bool () const;
		const Glib::ustring short_text() const;
		const Glib::ustring short_text(const std::string &) const;
	};
}
#endif // IGS_RESULT_HH
