/* ccgo: igs/sock.hh
 * 
 * Copyright 2002,2003 Chun-Chung Chen <cjj@u.washington.edu>
 *
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef IGS_SOCK_HH
#define IGS_SOCK_HH
#include "connect.hh"
#include <glibmm.h>
#include <string>
namespace igs
{
	class Sock :
		virtual public Connect
	{
		int sock_id;

		sigc::connection grab_line_connection;
		bool grab_action;
		bool grab_line(Glib::IOCondition);
		bool read_buffer();
		bool reading_buffer;

		sigc::connection time_up_connection;
		bool time_up();
		int idle_time;

	protected:
		std::string line_buffer;
	public:
		Sock(const std::string &, unsigned short);
		virtual ~Sock();
		void send_line(const std::string &);

		bool open_sock(const std::string &, unsigned short);
		void close_sock();
	};
}
#endif // IGS_SOCK_HH
