/* ccgo: igs/stats_box.hh
 * 
 * Copyright 2002,2003 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef IGS_STATS_BOX_HH
#define IGS_STATS_BOX_HH
#include "player.hh"
#include "result.hh"
#include <gtkmm/window.h>
#include <gtkmm/label.h>
#include <sigc++/signal.h>
#include <gtkmm/box.h>
#include <gtkmm/textview.h>
#include <gtkmm/entry.h>
namespace igs
{
	class StatsBox :
		public Gtk::VBox
	{
		Player player;
		std::string name;

		Gtk::Label rank;
		Gtk::Label rated_games;
		Gtk::HBox state_box;
		Gtk::Label state;
		Gtk::Button game;
		Gtk::Label reg_date;
		Gtk::Label idle_label;
		Gtk::Label idle_time;
		Gtk::Label address;

		Gtk::TextView info_box;

		void hit_game();

		Gtk::Button change;
		bool info_edit;
		void change_clicked();
	public:
		StatsBox(const std::string &);
		~StatsBox();
		void update(const Player &);
		void attach_result(const Result &);
		sigc::signal<void, int> select_game;
		void set_info_edit(bool = true);
		sigc::signal<void, const std::string &> info_change;
	};
}
#endif // IGS_STATS_BOX_HH
