/* ccgo: move.hh
 * 
 * Copyright 2002,2003 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef MOVE_HH
#define MOVE_HH
#include "game.hh"
#include "modifi.hh"
namespace go {
	class Move :
		virtual public Modifi
	{
	protected:
		bool checked;
		// preset:
		Turn turn;
		// to check:
		unsigned num;
		Turn pre_turn;
		int pre_num;
		Loc pre_ko;
		Loc pre_loc;
	public:
		Move(Turn);
		Move(const Move &);
		virtual ~Move();
		virtual Modifi * dup() const;
		void set_num(unsigned);
		unsigned get_num() const;
		virtual bool check(const Game &);
		virtual void apply(Game &) const;
		virtual void undo(Game &) const;
		virtual std::string as_string() const;
	};
}
#endif // MOVE_HH
