/* ccgo: node.hh
 * 
 * Copyright 2002,2003 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef NODE_HH
#define NODE_HH
#include <string>
#include <vector>
#include <iostream>
namespace go {
	class Node
	{
		Node * up_link;
		unsigned order;
		std::vector<Node *> link;
	protected:
		virtual Node * create_copy() const;
	public:
		Node();
		virtual ~Node();
		Node * dup() const;
		unsigned get_order() const;
		unsigned set_next(Node *);
		Node * get_next(unsigned = 0) const;
		Node * get_prev() const;
		unsigned get_link_size() const;
		void replace(Node *);
// 		void delete_tree();
		void delete_branch(unsigned = 0);
	};
}
#endif // NODE_HH
