/* ccgo: play_walk.hh
 * 
 * Copyright 2002,2003 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef PLAY_WALK_HH
#define PLAY_WALK_HH
#include "view_walk.hh"
#include "play_game.hh"
namespace go
{
	class PlayWalk :
		virtual public ViewWalk,
		virtual public PlayGame
	{
		bool player_enabled;
		void end_my_score();
		bool is_score;
		const Walk * play_node; // the node where playing is enabled
	public:
		PlayWalk(Node *);
		virtual ~PlayWalk();
		void set_play_node(const Walk *);
		void enable_player();
		void disable_player();
		void enter_scoring();
		void done_scoring();
		void do_player();
		virtual bool up();
		virtual bool down(unsigned = 0);
	};
}
#endif // PLAY_WALK_HH
