/* ccgo: proper_node.cc
 * 
 * Copyright 2002,2003 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#include "proper_node.hh"

using namespace go;
using namespace std;

Node * ProperNode::create_copy() const
{
	ProperNode * n = new ProperNode;
	if (proper) n->proper = proper->dup();
	return n;
}

ProperNode::ProperNode() :
	proper(0)
{
}

ProperNode::~ProperNode()
{
	if (proper) delete proper;
}

void ProperNode::set_proper(const Game & g, Proper * p)
{
	set_proper(p);
}

void ProperNode::set_proper(Proper * p)
{
	if (proper) delete proper;
	proper = p;
}

const Proper * ProperNode::get_proper() const
{
	return proper;
}

Proper * ProperNode::get_proper()
{
	return proper;
}
