/* ccgo: root_proper.cc
 * 
 * Copyright 2002,2003 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#include "root_proper.hh"

using namespace go;

RootProper::RootProper() :
	init(0)
{
	size = 19;
	komi = 0;
	handicap = 0;
}

RootProper::RootProper(const RootProper & p) :
	Proper(p)
{
	size = p.size;
	komi = p.komi;
	handicap = p.handicap;
	game_name = p.game_name;
	init = p.init ? p.init->dup() : 0;
}

Proper * RootProper::dup() const
{
	return new RootProper(* this);
}

void RootProper::set_size(unsigned z)
{
	size = z;
}

unsigned RootProper::get_size() const
{
	return size;
}

void RootProper::set_komi(double k)
{
	komi = k;
}

double RootProper::get_komi() const
{
	return komi;
}

void RootProper::set_handicap(unsigned h)
{
	handicap = h;
}

unsigned RootProper::get_handicap() const
{
	return handicap;
}

void RootProper::set_game_name(const std::string & n)
{
	game_name = n;
}

const std::string & RootProper::get_game_name() const
{
	return game_name;
}

void RootProper::set_init(const Board * b)
{
	if (init) delete init;
	init = b->Board::dup();
}

const Board * RootProper::get_init() const
{
	return init;
}
