/* ccgo: setup.hh
 * 
 * Copyright 2002,2003 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef SETUP_HH
#define SETUP_HH
#include "game.hh"
#include "modifi.hh"
#include <vector>
namespace go {
	class Setup :
		virtual public Modifi
	{
	public:
		class Site
		{
		public:
			Site(const Loc &, State);
			Loc loc;
			State state;
		};
	private:
		std::vector<Site> pre_state ;
		std::vector<Site> state;
		Turn pre_turn;
		Turn turn;
		Loc pre_ko;
		Loc pre_last_move;
	public:
		Setup(const std::vector<Site> &, Turn);
		Setup(const Setup &);
		virtual ~Setup();
		virtual Modifi * dup() const;
		virtual void check(const Game &);
		virtual void apply(Game &) const;
		virtual void undo(Game &) const;
	};
}
#endif // SETUP_HH
