/* ccgo: view_walk.cc
 * 
 * Copyright 2002,2003 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#include "view_walk.hh"
#include "proper_node.hh"
#include <sstream>
using namespace go;

ViewWalk::ViewWalk(Node * n) :
	Walk(n),
	Game(),
	GameWalk(n),
	ViewGame()
{
}

ViewWalk::~ViewWalk()
{
	// std::cerr << "deleting ViewWalk" << std::endl;
}

bool ViewWalk::up()
{
	return GameWalk::up();
}

bool ViewWalk::down(unsigned i)
{
	return GameWalk::down(i);
}

void ViewWalk::update_proper()
{
	clear_proper();
	ProperNode * pn = dynamic_cast<ProperNode *>(pos);
	if (pn == NULL || pn->get_proper() == NULL) return;
	set_proper(* pn->get_proper());
}
