/* ccgo: walk.hh
 * 
 * Copyright 2002,2003 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef WALK_HH
#define WALK_HH
#include "node.hh"
namespace go {
	class Walk
	{
	protected:
		Node * pos;
		unsigned num;
	public:
		Walk (Node *);
		Walk(const Walk &);
		virtual ~Walk();
		Node * get_pos();
		virtual bool up();
		unsigned n_down() const;
		virtual bool down(unsigned = 0);
		unsigned n_hop() const;
		virtual void hop(unsigned = 0);
		unsigned n();
		virtual unsigned pos_num() const;
		bool operator== (const Walk &) const;
		bool operator!= (const Walk &) const;
	};
}
#endif // WALK_HH
